/* devd-flatpak-app-provider.h
 *
 * Copyright 2018 Patrick Griffis <tingping@tingping.se>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */


#pragma once

#include <glib-object.h>

G_BEGIN_DECLS

#define DEVD_TYPE_FLATPAK_APP_PROVIDER (devd_flatpak_app_provider_get_type())
G_DECLARE_FINAL_TYPE (DevdFlatpakAppProvider, devd_flatpak_app_provider, DEVD, FLATPAK_APP_PROVIDER, GObject)

DevdFlatpakAppProvider *devd_flatpak_app_provider_new                   (void);
void                    devd_flatpak_app_provider_install_bundle_async  (DevdFlatpakAppProvider *self,
                                                                         const gchar            *path,
                                                                         GCancellable           *cancellable,
                                                                         GAsyncReadyCallback     callback,
                                                                         gpointer                user_data);
gboolean                devd_flatpak_app_provider_install_bundle_finish (DevdFlatpakAppProvider  *self,
                                                                         GAsyncResult            *result,
                                                                         GError                 **error);
G_END_DECLS
