/* devd-tls-certificate.h
 *
 * Copyright 2018 Christian Hergert <chergert@redhat.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#pragma once

#include <gio/gio.h>

G_BEGIN_DECLS

GTlsCertificate *devd_tls_certificate_new_generate        (const gchar          *public_key_path,
                                                           const gchar          *private_key_path,
                                                           const gchar          *c,
                                                           const gchar          *cn,
                                                           GCancellable         *cancellable,
                                                           GError              **error);
void             devd_tls_certificate_new_generate_async  (const gchar          *public_key_path,
                                                           const gchar          *private_key_path,
                                                           const gchar          *c,
                                                           const gchar          *cn,
                                                           GCancellable         *cancellable,
                                                           GAsyncReadyCallback   callback,
                                                           gpointer              user_data);
GTlsCertificate *devd_tls_certificate_new_generate_finish (GAsyncResult         *result,
                                                           GError              **error);
gchar           *devd_tls_certificate_get_hash            (GTlsCertificate      *cert);

G_END_DECLS
